<?php

class QUESTIONSANSW_CLASS_BaseBridge
{
    /**
     * Singleton instance.
     *
     * @var QUESTIONSANSW_CLASS_BaseBridge
     */
    private static $classInstance;

    /**
     * Returns an instance of class (singleton pattern implementation).
     *
     * @return QUESTIONSANSW_CLASS_BaseBridge
     */
    public static function getInstance()
    {
        if ( self::$classInstance === null )
        {
            self::$classInstance = new self();
        }

        return self::$classInstance;
    }
        
    public function onUserUnregister( OW_Event $event )
    {
        $params = $event->getParams();
        $userId = $params["userId"];
        
        // Delete QUESTIONSANSW        
        $questionsansw = QUESTIONSANS_BOL_Service::getInstance()->findQuestionsanswByUserId($userId);
        foreach ( $questionsansw as $question )
        {
            QUESTIONSANSW_BOL_Service::getInstance()->deleteQuestion($question->id);
        }
        
        // Delete Answers
        $answers = QUESTIONSANSW_BOL_Service::getInstance()->findAnswersByUserId($userId);
        foreach ( $answers as $answer )
        {
            QUESTIONSANSW_BOL_Service::getInstance()->removeAnswerById($answer->id);
        }
        
        // Delete Follows
        $follows = QUESTIONSANSW_BOL_Service::getInstance()->findFollowsByUserId($userId);
        foreach ( $follows as $follow )
        {
            QUESTIONSANSW_BOL_Service::getInstance()->removeFollow($follow->userId, $follow->questionId);
        }
        
        // Delete Activity
        $activityList = QUESTIONSANSW_BOL_FeedService::getInstance()->findActivityByUserId($userId);
        foreach ( $activityList as $activity )
        {
            /* @var $activity QUESTIONSANSW_BOL_Activity */
            QUESTIONSANSW_BOL_FeedService::getInstance()->deleteActivity($activity->questionId, $activity->activityType, $activity->activityId);
        }
    }
    
    public function init()
    {
        OW::getEventManager()->bind(OW_EventManager::ON_USER_UNREGISTER, array($this, "onUserUnregister"));
    }
}