<?php
class QUESTIONSANSW_CMP_Answer extends OW_Component
{
    /**
     *
     * @var QUESTIONSANSW_BOL_Service
     */
    private $service;

    /**
     *
     * @var QUESTIONSANSW_BOL_Option
     */
    private $option;

    private $voted = false, $voteCount = 0, $percents = 0, $userIds = array(), $multiple = true,
		$disabled = false, $editMode = false;

    public function __construct( QUESTIONSANSW_BOL_Option $opt, $uniqId)
    {
        parent::__construct();

        $this->option = $opt;

        $this->assign('questionUniqId', $uniqId);
    }

    public function setEditMode( $yes = true )
    {
            $this->editMode = $yes;
    }

    public function setVoteCount( $voteCount )
    {
        $this->voteCount = $voteCount;
    }

    public function setPercents( $percents )
    {
        $this->percents = $percents;
    }

    public function setVoted( $voted = true )
    {
        $this->voted = (bool) $voted;
    }

    public function setDisbled( $disabled = true )
    {
        $this->disabled = (bool) $disabled;
    }

    public function setUsers( $users )
    {
        $this->userIds = $users;
    }

    public function setIsMultiple( $multiple = true )
    {
        $this->multiple = $multiple;
    }

    public function onBeforeRender()
    {
        parent::onBeforeRender();

        $tplOption = array();
        $tplOption['id'] = $this->option->id;
        $tplOption['text'] = $this->option->text;
        $tplOption['count'] = $this->voteCount;
        $tplOption['percents'] = $this->percents;
        $tplOption['voted'] = $this->voted;
        $tplOption['multiple'] = $this->multiple;
        $tplOption['disabled'] = $this->disabled;
        $tplOption['editMode'] = $this->editMode;

        $avatarList = new QUESTIONSANSW_CMP_Avatars( $this->userIds, $this->voteCount );

        $tplOption['users'] = $avatarList->render();
        $this->assign('option', $tplOption);
    }

}