<?php
class QUESTIONS_CMP_Avatars extends OW_Component
{

    /**
     * Constructor.
     *
     * @param array $idList
     */
    public function __construct( array $idList, $totalCount )
    {
        parent::__construct();

        $userId = OW::getUser()->getId();
        $hiddenUser = false;
        if ( $userId && !in_array($userId, $idList) )
        {
            $hiddenUser = $userId;
            $idList[] = $userId;
        }

        $users = BOL_AvatarService::getInstance()->getDataForUserAvatars($idList, true, true, true, false);

        if ($hiddenUser)
        {
            $users[$hiddenUser]['id'] = $hiddenUser;
            $this->assign('hiddenUser', $users[$hiddenUser]);
            unset($users[$hiddenUser]);
        }

        $count = count($users);
        $otherCount = $totalCount - ($count > 3 ? 3 : $count);
        $otherCount = $otherCount < 0 ? 0 : $otherCount;

        $this->assign('otherCount', $otherCount);

        $this->assign('users', $users);

        $staticUrl = OW::getPluginManager()->getPlugin('questions')->getStaticUrl();
        $this->assign('staticUrl', $staticUrl);

    }

}