<?php
class QUESTIONSANSW_CTRL_Admin extends ADMIN_CTRL_Abstract
{
    public function getMenu()
    {
        $item[0] = new BASE_MenuItem(array());
        $item[0]->setLabel(OW::getLanguage()->text('questionsansw', 'admin_general_settings'));
        $item[0]->setIconClass('ow_ic_lens');
        $item[0]->setKey('1');
        $item[0]->setUrl(
            OW::getRouter()->urlForRoute('questionsansw-admin-main')
        );

        $item[0]->setOrder(1);

        $item[1] = new BASE_MenuItem(array());

        $item[1]->setLabel(OW::getLanguage()->text('questionsansw', 'admin_extended_version'));
        $item[1]->setIconClass('ow_ic_star q-extended-tab');
        $item[1]->setKey('2');
        $item[1]->setUrl(
            OW::getRouter()->urlForRoute('questionsansw-upgrade')
        );

        $item[1]->setOrder(2);

        return new BASE_CMP_ContentMenu($item);
    }

    public function main()
    {
        $language = OW::getLanguage();

        $this->setPageHeading($language->text('questionsansw', 'admin_main_page_heading'));
        $this->setPageTitle($language->text('questionsansw', 'admin_main_page_title'));
        $this->setPageHeadingIconClass('ow_ic_lens');

        $configs = OW::getConfig()->getValues('questionsansw');
        $this->assign('configs', $configs);

        $form = new QUESTIONSANSW_ConfigSaveForm($configs);

        $this->addForm($form);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) )
        {
            if ( $form->process($_POST) )
            {
                OW::getFeedback()->info($language->text('questionsansw', 'admin_settings_updated'));
                $this->redirect(OW::getRouter()->urlForRoute('questionsansw-admin-main'));
            }
        }

        $this->addComponent('menu', $this->getMenu());
    }
}

class QUESTIONSANSW_ConfigSaveForm extends Form
{
    private $configs = array();

    public function __construct( $configs )
    {
        parent::__construct('QUESTIONSANSW_ConfigSaveForm');

        $this->configs = $configs;

        $language = OW::getLanguage();

        $field = new CheckboxField('allow_comments');
        $field->setLabel($language->text('questionsansw', 'admin_allow_comments_label'));
        $field->setValue($configs['allow_comments']);
        $this->addElement($field);

        $field = new Selectbox('list_order');
        foreach ( array(QUESTIONSANSW_CMP_Feed::ORDER_LATEST, QUESTIONSANSW_CMP_Feed::ORDER_POPULAR) as $v )
        {
            $field->addOption($v, $language->text('questionsansw', 'feed_order_' . $v));
        }
        $field->setHasInvitation(false);
        $field->setLabel($language->text('questionsansw', 'admin_list_order_label'));
        $field->setValue($configs['list_order']);
        $this->addElement($field);

        $field = new CheckboxField('enable_follow');
        $field->setLabel($language->text('questionsansw', 'admin_enable_follow_label'));
        $field->setValue($configs['enable_follow']);
        $this->addElement($field);

        $field = new CheckboxField('allow_popups');
        $field->setLabel($language->text('questionsansw', 'admin_allow_popups_label'));
        $field->setValue($configs['allow_popups']);
        $this->addElement($field);

        // submit
        $submit = new Submit('save');
        $submit->setValue($language->text('questionsansw', 'admin_save_btn'));
        $this->addElement($submit);
    }

    public function process( $data )
    {
        $config = OW::getConfig();

        foreach ( $this->configs as $k => $v )
        {
            $element = $this->getElement($k);

            if ( $element !== null )
            {
                $v = $element->getValue();
                $config->saveConfig('questionsansw', $k, $v === null ? 0 : $v);
            }
        }

        return true;
    }
}